unit HFReader_DLL_Head;

interface

Const

    HFReader_DLLName = 'HFReader.dll';

    //==========================================================================================//
    Function OpenNetPort(Port : LongInt;
                    IPaddr:string;
                     var ComAdr : byte;
                     var frmcomportindex:longint): LongInt; stdcall;external HFReader_DLLName ;
    Function CloseNetPort( frmComPortindex : longint ): LongInt; stdcall; external HFReader_DLLName ;

    Function OpenComPort(Port : LongInt;var ComAdr : byte; var frmcomportindex: integer): LongInt; stdcall; external HFReader_DLLName ;
    Function CloseComPort(  ): LongInt; stdcall;external HFReader_DLLName ;
    Function AutoOpenComPort(var Port : longint; var ComAdr : byte; var frmComPortindex :integer ) : LongInt; stdcall; external HFReader_DLLName ;

    Function CloseSpecComPort( frmComPortindex : integer ): LongInt; stdcall;external HFReader_DLLName ;

    //==========================================================================================//
    Function Inventory(var ComAdr : byte; var State : byte;  var AFI : byte;
                       DSFIDAndUID : pchar;  var CardNum : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function StayQuiet(var ComAdr : byte; UID : pchar; var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall;external HFReader_DLLName ;

    Function ReadSingleBlock(var ComAdr : byte; var State : byte; UID : pchar;
                             BlockNum : byte; Var BlockSecStatus : Byte;
                             Data : pchar; var ErrorCode: byte;
                             frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

     Function ReadMultipleBlock(var ComAdr : byte;
                             var State : byte;
                             UID : pchar;
                              BlockNum : byte;
                              BlockCount :byte;
                              BlockSecStatus : pchar;
                             Data : pchar;
                             var ErrorCode: byte;
                             frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;
                                
    Function WriteSingleBlock(var ComAdr : byte;var State : byte; UID : pchar;
                              BlockNum : byte; Data : pchar;
                              var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function LockBlock(var ComAdr : byte; var State : byte; UID : pchar;
                       BlockNum : byte; var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function Select(var ComAdr : byte;UID : pchar; var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall;external HFReader_DLLName ;

    Function ResetToReady(var ComAdr : byte; var State : byte; UID : pchar;
                          var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function WriteAFI(var ComAdr : byte;var State : byte; UID : pchar;
                      AFI : byte;  var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall;external HFReader_DLLName ;

    Function LockAFI(var ComAdr : byte; var State : byte; UID : pchar;
                     var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function WriteDSFID(var ComAdr : byte; var State : byte; UID : pchar;
                        DSFID : byte; var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function LockDSFID(var ComAdr : byte;var State : byte; UID : pchar;
                       var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;

    Function GetSystemInformation(var ComAdr : byte;   var State : byte;
                                  UIDI : pchar;  var InformationFlag : byte;
                                  UIDO : pchar;  var DSFID : byte;
                                  var AFI : byte; MemorySize : pchar;
                                  var ICReference : Byte;
                                  var ErrorCode : byte; frmComPortindex : integer): LongInt; stdcall;external HFReader_DLLName ;
    Function GetReaderInformation(var ComAdr : byte;   VersionInfo : pchar;
                                  var ReaderType : Byte; TrType : pchar;
                                  var InventoryScanTime : Byte; frmComPortindex : integer): LongInt; stdcall;external HFReader_DLLName ;

    Function ChangeTo14443A(var ComAdr:byte;frmComPortindex : integer ): LongInt; stdcall; external HFReader_DLLName ;
    Function ChangeTo14443B(var ComAdr:byte;frmComPortindex : integer ): LongInt; stdcall; external HFReader_DLLName ;
    Function ChangeTo15693(var ComAdr:byte;frmComPortindex : integer ): LongInt; stdcall; external HFReader_DLLName ;
    Function ChangeToICODEUID(var ComAdr:byte;frmComPortindex : integer ): LongInt; stdcall; external HFReader_DLLName ;
    Function OpenRf(var ComAdr : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;
    Function CloseRf(var ComAdr : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;
    Function ChangeToStandby(var ComAdr : byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;
    Function WriteStandbyDelayTime(var ComAdr : byte;var _StandbyDelayTime:Byte;frmComPortindex : longint): LongInt; stdcall; external HFReader_DLLName ;
    Function WriteComAdr(var ComAdr : byte; var ComAdrData : Byte; frmComPortindex : integer): LongInt; stdcall; external HFReader_DLLName ;
    Function WriteInventoryScanTime(var ComAdr : byte; var InventoryScanTime : Byte; frmComPortindex : integer): LongInt; stdcall;external HFReader_DLLName ;
    Function SetLED(var ComAdr:byte;
                    OpenTime:byte;
                    CloseTime:byte;
                    RepeatCount:byte;
                    frmComPortindex : longint ): LongInt; stdcall; external HFReader_DLLName;
    Function SetBeep(var ComAdr:Byte;
                    OpenTime:Byte;
                    CloseTime:Byte;
                    RepeatCount:byte;
                    frmComPortindex : longint ): LongInt; stdcall;external HFReader_DLLName;

    Function ISO14443ARequest(var ComAdr : byte;Mode :byte; Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):longint; stdcall;  external HFReader_DLLName ;
    function ISO14443AAnticoll(var ComAdr : byte;Reserved :byte ;SN :pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AAnticoll2(var ComAdr : byte;EnColl:byte;Reserved:byte;SN:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AULAnticoll(var ComAdr : byte;Reserved :byte;SNR:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ASelect(var ComAdr : byte;SN:pchar ; var size:byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AAuthentication(var ComAdr : byte;keystyle:byte;sector:byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AAuthentication2(var ComAdr : byte;keystyle:byte;AccessSector:byte;AuthSector:byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AAuthKey(var ComAdr : byte;keystyle:byte;AccessSector:byte;Key:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AHalt(var ComAdr : byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ARead(var ComAdr : byte; Block:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer) :LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AWrite(var ComAdr : byte;Block:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AULWrite(var ComAdr : byte;ULPage:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AInitValue(var ComAdr : byte;Block:byte;InitValue:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AReadValue(var ComAdr : byte;Block:byte;Value:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AIncrement(var ComAdr : byte;Block:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ADecrement(var ComAdr : byte;Block:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ARestore(var ComAdr : byte;Addr:byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ATransfer(var ComAdr : byte;Addr:byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ALoadKey(var ComAdr : byte;KeyStyle:byte;Sector:byte;Key:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443ACheckWrite(var ComAdr : byte;SN:pchar;LastAhtnMode:byte;BlockAddr:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AReadE2(var ComAdr : byte;StartAddr:byte;DataLength:byte;ReturnData:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AWriteE2(var ComAdr : byte;WriteAddr:byte;DataLength:byte;Data:pchar;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;
    function ISO14443AValue(var ComAdr : byte;ChangeMode:byte;TargetAddr:byte;Data:pchar;SourceAddr:byte;var ErrorCode : byte;
                             frmComPortindex : integer):LongInt; stdcall;  external HFReader_DLLName ;

    function ISO14443BRequest(var ComAdr : byte;Mode:byte;AFI:byte;PUPI:pchar;ApplicationData:pchar;
                              ProtocolInfo:pchar ;var ErrorCode : byte;
                             frmComPortindex : integer):longint; stdcall;  external HFReader_DLLName ;
    function ISO14443BAnticoll(var ComAdr : byte;Mode:byte;AFI:byte;PUPI:pchar;ApplicationData:pchar;
                              ProtocolInfo:pchar ;var ErrorCode : byte;
                             frmComPortindex : integer):longint;stdcall;  external HFReader_DLLName ;
    function ISO14443BSelect(var ComAdr : byte;PUPI:pchar;CID :BYTE;Param1,Param2,Param3,Param4:byte;
                             var CIDO,MBLI:byte;var ErrorCode : byte;
                             frmComPortindex : integer):longint;stdcall;  external HFReader_DLLName ;
    function ISO14443BHalt(var ComAdr : byte;PUPI:pchar;var ErorCode:byte;
                           frmComPortindex : integer):longint;stdcall;  external HFReader_DLLName ;
    function ISO14443BTransparentCmd(var ComAdr : byte;Time_M:byte;Time_N:byte;CMD_Length:byte;RSP_Length:byte;
                                     CMD_Data :pchar;RSP_Data:pchar;var ErrorCode : byte;
                                    frmComPortindex : integer):longint;stdcall;  external HFReader_DLLName ;
                                    
    function SRI512_4K_Initiate(var ComAdr:Byte; 
                                var chipID:Byte;
                                var errorcode:Byte;
                                frmcomportindex:longint):LongInt;
                                stdcall;external HFReader_DLLName;

    function SRI512_4K_Select(var ComAdr:Byte;
                              var chipID:Byte;
                              var errorcode:Byte;
                              frmcomportindex:longint):LongInt;
                              stdcall;external HFReader_DLLName;

    function SRI512_4K_PCall16(var ComAdr:Byte;
                               var chipID:Byte;
                               var errorcode:Byte;
                               frmcomportindex:longint):LongInt;
                               stdcall;external HFReader_DLLName;

    function SRI512_4K_ResetToInventory(var ComAdr:Byte;
                                        frmcomportindex:longint):LongInt;
                                        stdcall;external HFReader_DLLName;

    function SRI512_4K_GetUID(var ComAdr:Byte;
                              UID:PChar;
                              var errorcode:Byte;
                              frmcomportindex:longint):LongInt;
                              stdcall;external HFReader_DLLName;

    function SRI512_4K_SlotMarker(var ComAdr:Byte;
                                  SlotNumber:Byte;
                                  var chipID:Byte;
                                  var errorcode:Byte;
                                  frmcomportindex:longint):LongInt;
                                  stdcall;external HFReader_DLLName;

    function SRI512_4K_Completion(var ComAdr:Byte;
                                  frmcomportindex:longint):LongInt;
                                  stdcall;external HFReader_DLLName;

    function SRI512_4K_ReadBlock(var ComAdr:Byte;
                                 blockaddr:Byte;
                                 blockdata:PChar;
                                 var errorcode:Byte;
                                 frmcomportindex:longint):LongInt;
                                 stdcall;external HFReader_DLLName;

    function SRI512_4K_WriteBlock(var ComAdr:Byte;
                                  blockaddr:Byte;
                                  blockdata:PChar;
                                  frmcomportindex:longint):LongInt;
                                  stdcall;external HFReader_DLLName;

    function ICODE_UID_Destroy(var comAdr:byte;
                               IDD,DestoryCode:PChar;
                               frmcomportindex:longint):LongInt;
                               stdcall;external HFReader_DLLName;

    function ICODE_UID_Write(var ComAdr:Byte;
                             blockStartAddr:Byte;
                             len:Byte;
                             blockdata:pchar;
                             frmcomportindex:longint):LongInt;
                             stdcall;external HFReader_DLLName;

    function ICODE_UID_Inventory(var comAdr:byte;
                                 IDDData:PChar;
                                 var cardNum:byte;
                                 frmcomportindex:longint):LongInt;
                                 stdcall;external HFReader_DLLName;

    function ISO15693TransparentCmd(var ComAdr : byte;
				Time_M:byte;
				Time_N:byte;
				CMD_Length:byte;
				RSP_Length:byte;
				CMD_Data :pchar;
				RSP_Data:pchar;
				frmComPortindex : longint):longint;
				stdcall;external HFReader_DLLName;

				
    function ISO14443ATransparentCmd(var ComAdr : byte;
				     Time_M:byte;
				     Time_N:byte;
				     CMD_Length:byte;
				     var RSP_Length:byte;
				     CMD_Data :pchar;
				     RSP_Data:pchar;
				     var ErrorCode : byte;
				     frmComPortindex : longint):longint;
				     stdcall;external HFReader_DLLName;
 function SetRATS28(var ComAdr : byte;
                         CMD_Data:pchar;
                         CMD_Length:Byte;
                          RSP_Data:pchar;
                           var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                           stdcall;external HFReader_DLLName;
    function SetPPS28(var ComAdr : byte;
                           CMD_Data:pchar;
                           CMD_Length:Byte;
                          RSP_Data:pchar;
                           var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                          stdcall;external HFReader_DLLName;
    function GetChallenge28(var ComAdr : byte;
                          CMD_Data:pchar;
                          CMD_Length:Byte;
                          RSP_Data:pchar;
                          var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                          stdcall;external HFReader_DLLName;
    function Des(keys:pchar;
                  nLen:byte;
                  InputData:pchar ;
                  CMD_Length:Byte;
                  outputData:pchar ;
                  mode:byte ;
                  encrypt:byte):longint ;
             stdcall;external HFReader_DLLName;
    function ExternalAuthenticate28(var ComAdr : byte;
                                   CMD_Data:pchar;
                                   CMD_Length:Byte;
                                  RSP_Data:pchar;
                                  var RSP_Length:byte;
                                  var ErrorCode : byte;
                                  frmComPortindex : longint):longint;stdcall;
                                stdcall;external HFReader_DLLName;
   function Erase28(var ComAdr : byte;
                          CMD_Data:pchar;
                          CMD_Length:Byte;
                          RSP_Data:pchar;
                          var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                          stdcall;external HFReader_DLLName;
   function CreateFile28(var ComAdr : byte;
                          CMD_Data:pchar;
                          CMD_Length:Byte;
                          RSP_Data:pchar;
                          var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                          stdcall;external HFReader_DLLName;
   function Writekey28(var ComAdr : byte;
                          CMD_Data:pchar;
                          CMD_Length:Byte;
                          RSP_Data:pchar;
                          var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                          stdcall;external HFReader_DLLName;
   function ReadBinaryFile28(var ComAdr : byte;
                          CMD_Data:pchar;
                          CMD_Length:Byte;
                          RSP_Data:pchar;
                          var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                           stdcall;external HFReader_DLLName;
   function UpdateBinary28(var ComAdr : byte;
                           CMD_Data:pchar;
                           CMD_Length:Byte;
                           RSP_Data:pchar;
                           var RSP_Length:byte;
                           var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                          stdcall;external HFReader_DLLName;
   function SendWTX28(var ComAdr : byte;
                          CMD_Data:pchar;
                          CMD_Length:Byte;
                          RSP_Data:pchar;
                          var RSP_Length:byte;
                          var ErrorCode : byte;
                          frmComPortindex : longint):longint;stdcall;
                           stdcall;external HFReader_DLLName;
  function CheckWTX28(CMD_Data:pchar;
                        CMD_Length:Byte):Boolean ;stdcall;
                           stdcall;external HFReader_DLLName;

  function Desfire_Rats(var ComAdr : byte;
                      CID:Byte;
                      RespData:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_Pps(var ComAdr : byte;
                      CID:Byte;
                      Divisor:Byte;
                      var RespData :Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_Authenticate(var ComAdr : byte;
                      CID:Byte;
                      KeyNo:Byte;
                      keys:pchar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
  function Desfire_ChangeKeySettings(var ComAdr : byte;
                      CID:Byte;
                      ChangeKeySettings :Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
  function Desfire_GetKeySettings(var ComAdr : byte;
                      CID:Byte;
                      var KeySettings :Byte;
                      var MaxNoOfKeys:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_ChangeKey(var ComAdr : byte;
                      CID:Byte;
                      KeyNo :Byte;
                      OldKey:PChar;
                      NewKey:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_GetKeyVersion(var ComAdr : byte;
                      CID:Byte;
                      KeyNo :Byte;
                      var KeyVer:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_CreateApplication(var ComAdr : byte;
                      CID:Byte;
                      AID :PChar;
                      KeySettings:Byte;
                      NumberOfKeys:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_DeleteApplication(var ComAdr : byte;
                      CID:Byte;
                      AID :PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_GetApplicationIDs(var ComAdr : byte;
                      CID:Byte;
                      AID :PChar;
                      var nNum:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_SelectApplication(var ComAdr : byte;
                      CID:Byte;
                      AID :PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_FormatPICC(var ComAdr : byte;
                      CID:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_GetVersion(var ComAdr : byte;
                      CID:Byte;
                      VerInfo:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_GetFileIDs(var ComAdr : byte;
                      CID:Byte;
                      FileIDs:PChar;
                      var NumberOfFileIDs:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_GetFileSettings(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      FileSettings:PChar;
                      var nLen:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_ChangeFileSettings(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      CommSet:Byte;
                      AccessRights:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_CreateStdDataFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      CommSet:Byte;
                      AccessRights:PChar;
                      FileSize:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_CreateBackupDataFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      CommSet:Byte;
                      AccessRights:PChar;
                      FileSize:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_CreateValueFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      CommSet:Byte;
                      AccessRights:PChar;
                      LowerLimit:PChar;
                      UpperLimit:PChar;
                      Value:PChar;
                      LimitedCreditEnabled  :Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_CreateLinearRecordDataFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      CommSet:Byte;
                      AccessRights:PChar;
                      RecordSize:PChar;
                      MaxNumOfRecords:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_CreateCyclicRecordDataFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      CommSet:Byte;
                      AccessRights:PChar;
                      RecordSize:PChar;
                      MaxNumOfRecords:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
   function Desfire_ClearRecordFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
  function Desfire_DeleteFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_ReadData(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Offset:PChar;
                      Length:PChar;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
  function Desfire_WriteData(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Offset:PChar;
                      Length:PChar;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
 function Desfire_GetValue(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Data:PChar;
                      var DataLen:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
function Desfire_Credit(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
function Desfire_Debit(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
 function Desfire_ClearRecordFile(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
 function Desfire_LitmitedCredit(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
 function Desfire_WriteRecord(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Offset:PChar;
                      Length:PChar;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
 function Desfire_ReadRecord(var ComAdr : byte;
                      CID:Byte;
                      FileNo:Byte;
                      Offset:PChar;
                      Length:PChar;
                      Data:PChar;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                      stdcall;external HFReader_DLLName;
 function Desfire_AbortTransaction(var ComAdr : byte;
                      CID:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
 function Desfire_CommitTransaction(var ComAdr : byte;
                      CID:Byte;
                      var ErrorCode : byte;
                      frmComPortindex : longint):longint;stdcall;
                       stdcall;external HFReader_DLLName;
implementation                   


end.













